﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using C1.Win.C1FlexGrid;
using System.Runtime.InteropServices;

namespace Prj_FilterEditorForm
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1FlexGrid1.Cols.Count = 5;
            c1FlexGrid1.Rows.Count = 20;
            for (int row = c1FlexGrid1.Rows.Fixed; row < c1FlexGrid1.Rows.Count; row++)
                for (int col = c1FlexGrid1.Cols.Fixed; col < c1FlexGrid1.Cols.Count; col++)
                {
                    c1FlexGrid1[row, col] = string.Format("Cell[{0}, {1}] This is a test to check the functionality related to Filter", row, col);
                }

            c1FlexGrid1.AllowFiltering = true;

            c1FlexGrid1.Cols[1].AllowFiltering = AllowFiltering.ByValue;
            ValueFilter vf = new ValueFilter();
            vf.ShowValues = new object[] { "Cell[1, 1] This is a test to check the functionality related to Filter" };
            c1FlexGrid1.Cols[1].Filter = vf;

            c1FlexGrid1.MouseClick += C1FlexGrid1_MouseClick;
        }

        [DllImport("user32.dll")]
        public static extern int SetScrollPos(IntPtr hWnd, Orientation nBar, int nPos, bool bRedraw);

        private void C1FlexGrid1_MouseClick(object sender, MouseEventArgs e)
        {
            if (c1FlexGrid1.HitTest(e.Location).Type == HitTestTypeEnum.FilterIcon)
            {
                foreach (Form frm in Application.OpenForms)
                {
                    if (frm.Name == "FilterEditorForm" && frm.GetType().ToString() == "C1.Win.C1FlexGrid.FilterEditorForm")
                    {
                        Control list;
                        try
                        {
                            list = frm.Controls[1].Controls[1].Controls[0];
                        }
                        catch
                        {
                            list = frm.Controls[1].Controls[0];
                        }
                        list.GetType().GetProperty("BoldCheckedItems").SetValue(list, false);
                        list.Font = new Font("monotype corsiva", 10);
                    }
                }
            }
        }
    }
}
